#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"

/*********************************************************************
 * The following definitions alter the functionality of the tool and *
 * can be adjusted to suit your needs                                *
 * CONNECTTIMEOUT - alarm() timeout for connect() function           *
 * SNDRCVTIMEOUT  - setsockopt() timeout for send() and recv()       *
 * BUFFSIZE       - character buffer size                            *
 * AGENT          - HTTP Application making request                  *
 * CONNECTION     - HTTP Connection Type                             *
 * ACCEPT         - HTTP Content Acceptance                          *
 * SOCKBUFF       - send & recv buffer size                          *
 * VERSION        - Application Release Version                      *
 * DEBUG          - verbose output                                   *
 ********************************************************************/
/* from sys/param.h */
#define MAXHOSTNAMELEN 256
#define PATH_MAX       1024

#define CONNECTTIMEOUT 5
#define SNDRCVTIMEOUT  5 
#define BUFFSIZE       1024 
#define SOCKBUFF       8192
#define PROTOCOL       "HTTP/1.0\r\n"
#define AGENT "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)\r\n"
#define ACCEPT         "Accept: */*\r\n" 

#define AIRONET        0
#define SWITCH         1
#define ROUTER         2
#define AIRONETLIST    3
#define ROUTERLIST     4
#define SWITCHLIST     5

#ifndef VERSION
#define VERSION        "0.1"
#endif

/* Global variable for http basic authentication */
int needauth;

void aironetquery(char *iptoscan, char *wwwauth, GtkWidget *text);

